
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class User_ratingsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_ratings = await db.user_ratings.create(
            {
                id: data.id || undefined,
        
        rating: data.rating
        ||
        null
            ,
            
        review: data.review
        ||
        null
            ,
            
        rated_at: data.rated_at
        ||
        null
            ,
            
        contains_spoilers: data.contains_spoilers
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await user_ratings.setUser( data.user || null, {
            transaction,
        });
        
        await user_ratings.setTitle( data.title || null, {
            transaction,
        });
        

        

        

        return user_ratings;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const user_ratingsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                rating: item.rating
            ||
            null
            ,
            
                review: item.review
            ||
            null
            ,
            
                rated_at: item.rated_at
            ||
            null
            ,
            
                contains_spoilers: item.contains_spoilers
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const user_ratings = await db.user_ratings.bulkCreate(user_ratingsData, { transaction });

        // For each item created, replace relation files
        

        return user_ratings;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const user_ratings = await db.user_ratings.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.rating !== undefined) updatePayload.rating = data.rating;
        
        
        if (data.review !== undefined) updatePayload.review = data.review;
        
        
        if (data.rated_at !== undefined) updatePayload.rated_at = data.rated_at;
        
        
        if (data.contains_spoilers !== undefined) updatePayload.contains_spoilers = data.contains_spoilers;
        
        
        updatePayload.updatedById = currentUser.id;

        await user_ratings.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await user_ratings.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.title !== undefined) {
            await user_ratings.setTitle(
              
              data.title,
              
              { transaction }
            );
        }
        

        
        

        

        return user_ratings;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const user_ratings = await db.user_ratings.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of user_ratings) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of user_ratings) {
                await record.destroy({transaction});
            }
        });


        return user_ratings;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const user_ratings = await db.user_ratings.findByPk(id, options);

        await user_ratings.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await user_ratings.destroy({
            transaction
        });

        return user_ratings;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const user_ratings = await db.user_ratings.findOne(
            { where },
            { transaction },
        );

        if (!user_ratings) {
            return user_ratings;
        }

        const output = user_ratings.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await user_ratings.getUser({
            transaction
        });
        
        
        output.title = await user_ratings.getTitle({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.titles,
        as: 'title',
        
        where: filter.title ? {
          [Op.or]: [
            { id: { [Op.in]: filter.title.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.title.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.review) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'user_ratings',
                        'review',
                        filter.review,
                    ),
                };
            }
            

            
            

            
            if (filter.ratingRange) {
                const [start, end] = filter.ratingRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rating: {
                    ...where.rating,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.rated_atRange) {
                const [start, end] = filter.rated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    rated_at: {
                    ...where.rated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    rated_at: {
                    ...where.rated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.contains_spoilers) {
                where = {
                    ...where,
                contains_spoilers: filter.contains_spoilers,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.user_ratings.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'user_ratings',
                        'review',
                        query,
                    ),
                ],
            };
        }

        const records = await db.user_ratings.findAll({
            attributes: [ 'id', 'review' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['review', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.review,
        }));
    }

    
};

